//
//      Cartoon.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.0 (English Edition)
//

#include "Cartoon.hpp"
#include "ImageWindow.hpp"
#include "cartoon.brh"

//
// The Boot loader function.
// It is called when the application starts.
//
SFCApplet::FactorySPP SFCApplet::Boot(AEECLSID id, SFXAnsiStringPtr license)
{
    *license = "heap://"
        "Z9R4W0XOZ3X4RLR2U9Z6XQ41YOX9W5R5Y1VMX6YFK8TLT715AUFX6S1KS5HUDR35XOS0Y1W8T2S4SLZ1"
        "SKHTIYBHRARDR2UQLXAW8UOVJGVEU3WFWAZ5UIXFSFWBSNLT5V6VPDROSGV8YNZ5WFXDTAW8UMSKEXOR"
        "NW7R2RLSETJUKXGXBHWBYBW5Y5REUCVPT8RJXISFW0TDSMYHW5UIV4T8ULUA97ZCXOV3X0XJSG432X1Y"
        "AVPXLYGT2TESHV0WPU6TFVCTEYBT8YDXHWET8RDY2YIULWFTNHVEXPRBRIEVJX0TMY1WER6Y6X1RIX3P"
        "RKYKLT4VMUKUC1V27W9VJTNVIVCZ9YFYJTI/";

    return (id == AEECLSID_CARTOON) ? (&Cartoon::Factory) : (null);
}

//
// The factory function.
// An instance of the application class is generated and returned.
//
SFCInvokerPtr Cartoon::Factory(Void)
{
    return ::new Cartoon;
}

//
// Constructor definition.
//
Cartoon::Cartoon(Void) static_throws
{
    // Various handlers are registered here

    // Error handling
    if (static_try()) {
        static_throw(RegisterHandler(SREVT_RESPONDER_RENDER, SRP16_RENDER_CONTENT, HANDLER_BEFORE, HANDLER_FUNCTION(OnRenderContent)));
    }
    if (static_try()) {
        static_throw(RegisterHandler(SFEVT_KEY, HANDLER_AFTER, HANDLER_FUNCTION(OnKey)));
    }

    // Obtain the device screen size
    m_devsize = SFXGraphics::GetDeviceSize();

    // Determine whether the device is QVGA compatible
    if (240 <= m_devsize.GetWidth() && 240 <= m_devsize.GetHeight()) {
        m_qvga_ratio = 2;
    }
    else {
        m_qvga_ratio = 1;
    }

    // Initialize the displayed image index number
    m_pict_index = 0;
    return;
}

//
// Destructor definition.
// Nothing special is done here.
//
Cartoon::~Cartoon(Void)
{
    return;
}

//
// Drawing handler.
// Drawing processes are described here.
//
HANDLER_IMPLEMENT_VOIDRENDER(Cartoon, OnRenderContent, graphics)
{
    // Clear display with background color
    graphics->FillRectangle(GetContentWorld(), SFXRGBColor(192, 192, 192, 255));

    // Perpendicular distance between image and screen edge
    SIntN blank1 = (m_devsize.GetWidth() - PICTSIZE) / 2;

    // Perpendicular distance between image and navigation keys
    SIntN blank2 = (m_devsize.GetHeight() - blank1 - PICTSIZE) / 4;

    // Draw the image frame
    graphics->SetForeColor(SFXRGBColor(0, 0, 0, 255));
    graphics->DrawRectangle(SFXRectangle(blank1 - 1, blank1 - 1, PICTSIZE + 2, PICTSIZE + 2));

    // Draw the navigation keys (Prev, Zoom, Next)
    graphics->SetFillColor(SFXRGBColor(128, 128, 128, 255));
    graphics->DrawRoundRectangle(SFXRectangle(blank1, blank1 + blank2 + PICTSIZE, NAVI_WIDTH, NAVI_HEIGHT ),SFXSize(3, 3));
    graphics->DrawRoundRectangle(SFXRectangle(blank1 + NAVI_X_POS_2, blank1 + blank2 + PICTSIZE, NAVI_WIDTH, NAVI_HEIGHT ), SFXSize(3, 3));
    graphics->DrawRoundRectangle(SFXRectangle(blank1 + NAVI_X_POS_3, blank1 + blank2 + PICTSIZE, NAVI_WIDTH, NAVI_HEIGHT ), SFXSize(3, 3));

    graphics->SetForeColor(SFXRGBColor(0, 0, 0, 255));
    if (m_pict_index >= 1) {
        graphics->DrawText("Prev", SFXRectangle(blank1, blank1 + blank2 + PICTSIZE, NAVI_WIDTH, NAVI_HEIGHT ) );
    }
    if (1 <= m_pict_index && m_pict_index <= 4) {
        graphics->DrawText("Zoom", SFXRectangle(blank1 + NAVI_X_POS_2, blank1 + blank2 + PICTSIZE, NAVI_WIDTH, NAVI_HEIGHT ) );
    }
    if (m_pict_index <= 4) {
        graphics->DrawText("Next", SFXRectangle(blank1 + NAVI_X_POS_3, blank1 + blank2 + PICTSIZE, NAVI_WIDTH, NAVI_HEIGHT ) );
    }

    // Draw the "start" and "end" strings
    if (m_pict_index == 0) {
        graphics->DrawText("Start", SFXRectangle(blank1, blank1, PICTSIZE, PICTSIZE), IDF_ALIGN_CENTER | IDF_ALIGN_MIDDLE);
        return;
    }
    else if (m_pict_index == 5) {
        graphics->DrawText("End", SFXRectangle(blank1, blank1, PICTSIZE, PICTSIZE), IDF_ALIGN_CENTER | IDF_ALIGN_MIDDLE);
        return;
    }
    else if (1 <= m_pict_index && m_pict_index <= 4) {
        // Display the bitmap image
        if (m_bitmap != null) {
            if (m_qvga_ratio == 2) {

                // For QVGA devices
                SFBBitmapSmp     pSourceBitmap;
                SFBTransformSmp  pTransform;
                SFXSize          size(PICTSIZE_ORIG, PICTSIZE_ORIG);

                // Generate a Bitmap instance
                pSourceBitmap = graphics->CreateBitmap(size);
                // Store the image in the Bitmap instance
                pSourceBitmap->BltIn(SFXRectangle(0, 0, size), m_bitmap, SFXGrid(0, 0));

                // Generate a Transform instance
                pTransform = SFBTransform::NewInstance(graphics->GetDestination());

                // Expand and draw the image
                pTransform->TransformBltSimple(SFXGrid(blank1 + PICTSIZE_ORIG / 2, blank1 + PICTSIZE_ORIG / 2), pSourceBitmap,
                                               SFXRectangle(0, 0, size), TRANSFORM_SCALE_2);
            }
            else if (m_qvga_ratio == 1) {

                // For non-QVGA devices
                graphics->DrawBitmap(m_bitmap, SFXGrid(blank1, blank1));
                // SFXGrid is a shape class for declaring coordinates
            }
        }
    }
}

//
// Loads the corresponding bitmap from resource.
// Index stands for picture number (1 to 4).
//
SFBBitmapSmp Cartoon::LoadBitmap(SIntN index)
{
    if (1 <= index && index <= 4) {
        SFBShellSmp shell = SFBShell::GetInstance();
        // Load the image and return a pointer to it
        return shell->LoadResBitmap(CARTOON_RES_FILE, IDI_PICT1 + index - 1);
    }
    else {
        return SFBBitmapSmp(NULL);
    }
}

//
// Key handler.
// Drawing processes are described here.
//
HANDLER_IMPLEMENT_BOOLEVENT(Cartoon, OnKey, event)
{
    UInt16 key = event.GetP16();
    switch (key) {
    case AVK_RIGHT:     //When right key is pressed
        if (m_pict_index <= 4) {
            m_pict_index++;                      // Next picture
            m_bitmap = LoadBitmap(m_pict_index); // Load bitmap
            InvalidateContent();                 // Redraw
        }
        return true;

    case AVK_LEFT:      // When left key is pushed
        if (m_pict_index >= 1) {
            m_pict_index--;                      // Previous picture
            m_bitmap = LoadBitmap(m_pict_index); // Load bitmap
            InvalidateContent();                 // Redraw
        }
        return true;

     // The image window is generated and displayed with the select key
    case AVK_SELECT:
        if (1 <= m_pict_index && m_pict_index <= 4) {
            // Generates the ImageWindow
            new ImageWindow(this, GetContentWorld(), m_bitmap);
        }
        return true;
    }
    return false;
}
