//
//     Copyright (C) 2003 - 2007 SophiaCradle, Inc.
//     All rights reserved.
//
//     File: ImageWindow.hpp
//

#ifndef _IMAGEWINDOW_HPP
#define _IMAGEWINDOW_HPP

#include <SophiaFramework.hpp>

//
// ImageWindow Class for expanding and displaying bitmaps.
//

SFMTYPEDEFCLASS(ImageWindow)
class ImageWindow : public SFRPlainWindow {

    // Macro used for copy protection
    SFMSEALCOPY(ImageWindow)

private:

    // Bitmap to display
    SFXBrewPointer<SFBBitmap> m_bitmap;

    // Coordinate of the top left corner to be transferred
    SFXGrid m_transfered_point;

    // Display size of the device
    SFXSize m_devsize;

    // The original bitmap size before enlarging
    SFXSize m_bitmap_size;

    // Scale ratio of the bitmap
    Float64 m_scale_ratio;

public:

    // Constructor
    ImageWindow(SFRApplicationPtr, SFXRectangleConstRef, SFBBitmapSmpConstRef);

private:

    // Destructor
    virtual ~ImageWindow();

    // Drawing handler
    HANDLER_DECLARE_VOIDRENDER(OnDraw)
    // Key handler
    HANDLER_DECLARE_BOOLEVENT(OnKey)
};

#endif  //_IMAGEWINDOW_HPP
